
#property  copyright "Copyright ?2004, MetaQuotes Software Corp."
#property  link      "http://www.metaquotes.net/"

#property  indicator_separate_window
#property  indicator_buffers 1
#property  indicator_color1  Yellow
#property  indicator_width1  1

extern int FastEMA=12;
extern int SlowEMA=26;
extern int SignalSMA=9;

double     diff[], dea[], hist[], histupdn[];

int init(){

   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexDrawBegin(1,SignalSMA);
   IndicatorDigits(Digits+1);

   SetIndexBuffer(0,histupdn);

   IndicatorShortName("MACD show hist up down02("+FastEMA+","+SlowEMA+","+SignalSMA+")");
   SetIndexLabel(0,"histud02");

   return(0);
  }

int start(){
  int limit;
  int counted_bars=IndicatorCounted();

  if(counted_bars>0) counted_bars--;
  limit=Bars-counted_bars;
  ArrayResize(diff,limit+2);
  ArrayResize(dea,limit+2);
  ArrayResize(hist,limit+2);
  for(int i=0; i<limit; i++)
    diff[i]=iMA(NULL,0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i)-iMA(NULL,0,SlowEMA,0,MODE_EMA,PRICE_CLOSE,i);

  for(i=0; i<limit; i++)
    dea[i]=iMAOnArray(diff,Bars,SignalSMA,0,MODE_SMA,i);

  for(i=0; i<limit; i++)
    hist[i]=diff[i]-dea[i];

  for(i=1; i<limit; i++){
    if(hist[i]>hist[i-1]) histupdn[i]=1;
    if(hist[i]<hist[i-1]) histupdn[i]=-1;
 }
   return(0);
}
//+------------------------------------------------------------------+